//// INCLUDES ////

//// DEFINES ////
#define OD_MEASUREMENT_TIME 500
#define OD_SENSOR_PIN 2

#define BAUD_RATE 9600

//// VARIABLES ////
unsigned long last_time;
volatile unsigned long counter;

//// METHODS ////
void SendMessage(int sender, int receiver, int type, String contents[]);
void do_od_measurement();

void od_interrupt_process(){counter++;} // INterrupt function to be called at every rising edge

void setup(){
  /// Comunication ///
  Serial.begin(BAUD_RATE);
  
  /// OD measurement
  pinMode(OD_SENSOR_PIN, INPUT);
  digitalWrite(OD_SENSOR_PIN, HIGH);
  attachInterrupt(0, od_interrupt_process, RISING);
  
  last_time = millis();
}

void loop(){
  do_od_measurement();
}

void do_od_measurement(){
  if(millis() - last_time >= OD_MEASUREMENT_TIME){ // No delay should be used
  
    String send_value;
    send_value += counter;
    counter = 0;
  
    String package[] = { "Biomass", send_value, "-" };
    SendMessage(2, 0, 0, package);
    
    last_time = millis();
  }
}

void SendMessage(int sender, int receiver, int type, String contents[])
{
  Serial.write(sender);
  Serial.write(receiver);
  Serial.write(type);
  for (int c = 0; c < sizeof(contents) + 1; c++)//print each string
  {
    if (c < sizeof(contents))       //tab separated
      Serial.print(contents[c] + '\t');
    else
    {
      Serial.print(contents[c]);    //the last one does not have a tab
      Serial.println();             //but finishes
    }
  }
}
